'Compilable Example:
#Compile Exe "gbchildsafe.exe"
#Dim All

'#Debug Error On
'#Debug Display On

%Unicode = 1
%UseWebBrowser = 1            ' // Use the WebBrowser control

%TBM = 60
%Res_EXE  = 888
%Res_Time = 997
%Res_All  = 998
%Res_MD5  = 999
%Res_PSW  = 1000

$SafeSites = "files\safesites.txt"
$Ver = "1.0"

#Include Once "CWindow.inc"   ' // CWindow class
#Include "mmdeviceapi.inc"      ' -- Headers with COM classes declarations,
#Include "endpointvolume.inc"   ' -- translated from Windows Platform SDK by Jos Roca

#Resource Manifest, 1, "files\xptheme.xml"

#Resource Icon logo "icons\gbchildsafe.ico"
#Resource Icon xlock "icons\lock.ico"
#Resource Icon xsettings "icons\settings.ico"
#Resource Icon xhelp "icons\help.ico"
#Resource Icon xxprint "icons\print.ico"
#Resource Icon xplus "icons\plus.ico"
#Resource Icon xminus "icons\minus.ico"
#Resource Icon xnext "icons\next.ico"
#Resource Icon xprevious "icons\previous.ico"
#Resource Icon xhome "icons\home.ico"
#Resource Icon xcapture "icons\camera.ico"
#Resource Icon xarrow "icons\arrow.ico"
#Resource Icon xedit "icons\edit.ico"
#Resource Icon xlock "icons\lock.ico"
#Resource Icon xsave "icons\save.ico"
#Resource Icon xsoundblock "icons\soundblock.ico"
#Resource Icon xsoundplus "icons\soundplus.ico"
#Resource Icon xsoundminus "icons\soundminus.ico"
#Resource Icon xchild "icons\child.ico"
#Resource Icon xparent "icons\parent.ico"
#Resource Icon xtimer "icons\timer.ico"

#Resource RcData, 888, "files\gbchangepsw.exe"
#Resource String, 997, "28800"$$, 2048                             'Seconds left to browse 6 char max
#Resource String, 998, "1"$$, 2048                                 'AllDomain Access 1 char
#Resource String, 999, "32F032C26CD17FC64E2DA6EA25742A11"$$, 2048  'MD5  32 char exactly
#Resource String, 1000, "please    "$$, 2048                       'PassWord   10 char max

Declare Function CryptGetHashParamX Lib "AdvAPI32.dll" Alias "CryptGetHashParam" _
   (ByVal hHash As Dword, ByVal dwParam As Dword, ByVal pbData As Byte Ptr, _
   pdwDataLen As Dword, ByVal dwFlags As Dword) As Long

Type CustomColors
   c(15) As Long
End Type

Enum Equates Singular
   IDC_WebBrowser = 500
   IDC_StatusBar
   IDC_Toolbar
   IDC_Graphic
   IDC_TextBox
   IDC_ImgButton

   IDT_Home
   IDT_Capture
   IDT_Edit
   IDT_Password
   IDT_Parent
   IDT_Timer
   IDT_Child
   IDT_Add
   IDT_Remove
   IDT_Next
   IDT_Previous
   IDT_SoundBlock
   IDT_SoundPlus
   IDT_SoundMinus
   IDT_Print
   IDT_Settings
   IDT_Help

   ID_Timer

   IDM_Sep
   IDM_Test
   IDM_Lock

   IDM_SetAsHomeSite
   IDM_BGColor
   IDM_MoveToTop

   IDM_Capture64
   IDM_Capture128
   IDM_Capture192
   IDM_Capture256

   IDM_Timer1
   IDM_Timer2
   IDM_Timer4
   IDM_Timer8

   IDM_Browse
   IDM_AddToSafeSiteList
   IDM_AllDomain
End Enum

Global hDlg,hToolbar,hGraphic,hGraphicDC,hDlgC As Dword
Global hContextWB,hContextG,ghHook,hBrowser,hCapture,hTextBox As Dword
Global CustomColorList As CustomColors, hSettings, hTimer, hTooltip, hImgButton As Dword
Global Admin, CurrentSite, SupportsMD5, Restart, AllDomain, TimeSlot,TimeRemaining As Long
Global DirtyList, Mute, CaptureSize, BGColor, CaptureInWork As Long
Global NewPSW, MD5, HomeSite, WebSite, Sites() As String

'Web Browser
Global pWindow As IWindow, pWBEvents As DWebBrowserEvents2Impl
'Encryption
Global hProv As Dword, strHash As String * 16, strHashPtr As Byte Ptr

Function PBMain
   InitializeCrypto
   Dialog Font Default "Tahoma", 10, 0
   Dialog New Pixels, 0, "gbChildSafe Web Browser  v" + $ver, , , 600, 400, %WS_OverlappedWindow To hDlg
   Dialog Set Icon hDlg, "logo"
   CreateToolbar
   CreateGraphic
   Control Add TextBox, hDlg, %IDC_TextBox, "",110,%TBM,200,25
   Control Handle hDlg, %IDC_TextBox To hTextBox
   CreateImgButton
   Control Add Statusbar, hDlg, %IDC_Statusbar, "", 0,0,0,0
   Statusbar Set Parts hDlg, %IDC_StatusBar, 40,9999
   Dialog Show Modal hDlg, Call DlgProc
   If hProv = 0 Then CryptReleaseContext hProv, 0
   If DirtyList Then RunChangePSW
End Function

CallBack Function DlgProc() As Long
   Local iResult As Long, temp$,tmp$, pt As Point
   Local pIWebBrowser2 As IWebBrowser2, vURL As Variant
   Local PTT As TooltipText Ptr, NMTB As TBNotify Ptr, rc As Rect
   Select Case Cb.Msg
      Case %WM_InitDialog
         If IsFile("gbchangepsw.exe") Then Kill "gbchangepsw.exe"
         BuildAcceleratorTable
         CreateContextMenus
         AllDomain = Val(Resource$(String,%Res_All))
         TimeRemaining = Val(Resource$(String,%Res_Time))
         settings_ini "get"
         GetSiteList
         WebSite = Sites(CurrentSite)
         Statusbar Set Text hDlg, %IDC_Statusbar, 2, 0, WebSite
         CreateWebBrowser
         If SiteListTampered Then Dialog End hDlg : Exit Function
         Graphic Set Virtual 80, 20 + 80 * UBound(Sites)
         ManageToolbar
         SetMenusAndToolbar
         DrawPreviewImages
         TimeRemaining = 8 * 3600 + 1
         Statusbar Set Text hDlg, %IDC_Statusbar, 1, 0, TimeString
         SetTimer hDlg, %ID_Timer, 20000, ByVal %Null
         Dialog Post hDlg, %WM_User+500, 0,0

      Case %WM_User+500
         Graphic Set View 0, 80 * (CurrentSite-1)

      Case %WM_ContextMenu
         Select Case Cb.WParam
            Case hGraphic
               pt.x = Lo(Integer,Cb.LParam) : pt.y = Hi(Integer, Cb.LParam)    'WM_ContextMenu returns xy coordinates of mouse
               TrackPopupMenu hContextG, %TPM_LeftAlign, pt.x, pt.y, 0, hDlg, ByVal 0   'put context menu where mouse is
         End Select

      Case %WM_Timer
         Decr TimeRemaining
         Statusbar Set Text hDlg, %IDC_Statusbar, 1, 0, TimeString
         If TimeRemaining <= 0 Then
            MsgBoxx "No more time!", %MB_Ok + %MB_IconExclamation + %MB_TaskModal, "Time Monitor"
            Dialog End hDlg
         End If

      Case %WM_Command
         Select Case Cb.Ctl
            Case %IdOk
               Select Case GetFocus
                  Case hTextbox
                     Control Get Text hDlg, %IDC_TextBox To WebSite
                     vURL = WebSite
                     pIWebBrowser2 = OC_GetDispatch(hBrowser)
                     pIWebBrowser2.Navigate2 vURL
               End Select

            Case %IDT_Edit
               If Admin Then
                  Open $SafeSites For Binary As #1 : Get$ #1, Lof(1), tmp$ : Close #1   'before editing
                  Shell("Notepad " + $SafeSites, 1)
                  Open $SafeSites For Binary As #1 : Get$ #1, Lof(1), temp$ : Close #1  'after editing
                  If tmp$ <> temp$ Then
                     CurrentSite = 1
                     DirtyList = 1
                     GetSiteList
                     DrawPreviewImages
                     WebSite = Sites(CurrentSite)
                     Statusbar Set Text hDlg, %IDC_Statusbar, 2, 0, WebSite
                     Control Set Text hDlg, %IDC_TextBox, WebSite
                     vURL = WebSite
                     pIWebBrowser2 = OC_GetDispatch(hBrowser)
                     pIWebBrowser2.Navigate2 vURL
                  End If
               Else
                  Beep
               End If

            Case %IDT_Password
               If Admin Then
                  Dialog Get Loc hDlg To pt.x, pt.y
                  ghHook = SetWindowsHookEx(%WH_CBT, CodePtr(InputBoxProc), GetModuleHandle(""), GetCurrentThreadId)
                  temp$ = InputBox$("", "Enter New Password:", Trim$(Resource$(String,%Res_PSW)), pt.x+100,pt.y+100)
                  UnhookWindowsHookEx ghHook
                  temp$ = Trim$(temp$)
                  If temp$ <> Trim$(Resource$(String,%Res_PSW)) Then
                     NewPSW = temp$
                     DirtyList = 1
                  End If
               Else
                  Beep
               End If

            Case %IDT_Add, %IDM_AddToSafeSiteList
               DirtyList = 1
               CreateWebSiteImageDefault
               AddNewSite
               DrawPreviewImages   'draw 64x64 images on the Graphic Control

            Case %IDT_Remove
               Array Scan Sites(), Collate UCase, = WebSite, To iResult
               If iResult Then
                  Select Case MsgBoxX("Remove " + Sites(CurrentSite), %MB_OkCancel + %MB_TaskModal + %MB_IconQuestion, "Remove Site")
                     Case %IdOk
                        DirtyList = 1
                        Array Delete Sites(CurrentSite)
                        ReDim Preserve Sites(UBound(Sites)-1)
                        If CurrentSite > UBound(Sites) Then Decr CurrentSite
                        WebSite = Sites(CurrentSite)
                        Statusbar Set Text hDlg, %IDC_Statusbar, 2, 0, WebSite
                        DrawPreviewImages
                        vURL = WebSite
                        pIWebBrowser2 = OC_GetDispatch(hBrowser)
                        pIWebBrowser2.Navigate2 vURL
                  End Select
               Else
                  MsgBoxX "Currently displayed site is not in Site List!", %MB_Ok + %MB_TaskModal + %MB_IconExclamation,"Remove Site"
               End If

            Case %IDT_Capture
               If CaptureInWork = 0 Then
                  CaptureInWork = 1
                  Statusbar Set Text hDlg, %IDC_Statusbar, 2,0, "Drag over image to capture. Click to capture. Right-Click to close."
                  CreateImageCaptureDialog
               Else
                  CaptureInWork = 0
                  Dialog End hDlgC
               End If

            Case %IDT_Previous
                pIWebBrowser2 = OC_GetDispatch(hBrowser)
                pIWebBrowser2.GoBack

            Case %IDT_Next
                pIWebBrowser2 = OC_GetDispatch(hBrowser)
                pIWebBrowser2.GoForward

            Case %IDT_SoundMinus : Mute = 0    : ManageVolume -1 : SetMenusAndToolbar
            Case %IDT_SoundBlock : Mute Xor= 1 : ManageVolume  0 : SetMenusAndToolbar
            Case %IDT_SoundPlus  : Mute = 0    : ManageVolume +1 : SetMenusAndToolbar

            Case %IDT_Timer
               TimeRemaining = TimeSlot * 3600

            Case %IDT_Home
               WebSite = HomeSite
               Statusbar Set Text hDlg, %IDC_Statusbar, 2, 0, WebSite
               pIWebBrowser2 = OC_GetDispatch(hBrowser)
               vURL = HomeSite
               pIWebBrowser2.Navigate2 vURL

            Case %IDT_Print  'PrintPreview
                pIWebBrowser2 = OC_GetDispatch(hBrowser)
                pIWebBrowser2.ExecWB %OLECMDID_PRINTPREVIEW, %OLECMDEXECOPT_PROMPTUSER

            Case %IDT_Settings

            Case %IDT_Help
               If Admin Then
                  iResult = ShellExecute(hDlg, "Open", "http://www.garybeene.com/sw/gbchildsafe.htm", $Nul, $Nul, %SW_ShowNormal)
               Else
                  temp$ += "To visit a site, click an image on the left side of the screen!"
                  temp$ += $CrLf + $CrLf
                  temp$ += "To change the image, click on SnapShot" + $CrLf
                  temp$ += "- then drag the selection screen over an image" + $CrLf
                  temp$ += "- double click to capture" + $CrLf
                  temp$ += "- right click to cancel" + $CrLf
                  temp$ += "- click on the down arrow to change the selection size"
                  temp$ += $CrLf + $CrLf
                  temp$ += "Press Mute to stop all sound"
                  temp$ += $CrLf + $CrLf
                  temp$ += "Press Print to get Print Preview"
                  MsgBoxX temp$, %MB_Ok + %MB_TaskModal + %MB_IconInformation, "gbChildSafe Web Browser Local Help"

               End If

            Case %IDC_ImgButton
               Control Get Text hDlg, %IDC_TextBox To WebSite
               vURL = WebSite
               pIWebBrowser2 = OC_GetDispatch(hBrowser)
               pIWebBrowser2.Navigate2 vURL

            Case %IDC_Graphic
               Select Case Cb.CtlMsg
                  Case %STN_Clicked
                     If SiteUnderCursor <= UBound(Sites) Then
                        CurrentSite = SiteUnderCursor
                        DrawPreviewImages
                        WebSite = Sites(CurrentSite)
                        Control Set Text hDlg, %IDC_TextBox, WebSite
                        Statusbar Set Text hDlg, %IDC_Statusbar, 2, 0, WebSite
                        vURL = WebSite
                        pIWebBrowser2 = OC_GetDispatch(hBrowser)
                        pIWebBrowser2.Navigate2 vURL
                     End If
               End Select

            Case %IDM_Lock, %IDT_Parent, %IDT_Child   : ManageLock

            Case %IDM_Capture64   : CaptureSize = 64  : SetMenusAndToolbar
            Case %IDM_Capture128  : CaptureSize = 128 : SetMenusAndToolbar
            Case %IDM_Capture192  : CaptureSize = 192 : SetMenusAndToolbar
            Case %IDM_Capture256  : CaptureSize = 256 : SetMenusAndToolbar

            Case %IDM_Timer1 : TimeSlot = 1
            Case %IDM_Timer2 : TimeSlot = 2
            Case %IDM_Timer4 : TimeSlot = 4
            Case %IDM_Timer8 : TimeSlot = 8

            Case %IDM_SetAsHomeSite
               HomeSite = Sites(CurrentSite)

            Case %IDM_BGColor
               iResult = SelectColor(BGColor)
               If iResult <> BGColor Then BGColor = iResult : DrawPreviewImages

            Case %IDM_MoveToTop
               If SiteUnderCursor <= UBound(Sites) Then
                  DirtyList = 1
                  temp$ = Sites(SiteUnderCursor)
                  Array Delete Sites(SiteUnderCursor)
                  Array Insert Sites(1), temp$
                  CurrentSite = 1
                  DrawPreviewImages
                  Graphic Set View 0,0
                  WebSite = Sites(CurrentSite)
                  Statusbar Set Text hDlg, %IDC_Statusbar, 2, 0, WebSite
                  Control Set Text hDlg, %IDC_TextBox, WebSite
                  vURL = WebSite
                  pIWebBrowser2 = OC_GetDispatch(hBrowser)
                  pIWebBrowser2.Navigate2 vURL
               End If

            Case %IDM_Browse
               If Admin Then Control Set Focus hDlg, %IDC_TextBox

            Case %IDM_AllDomain
               AllDomain Xor=1
               DirtyList = 1
               SetMenusAndToolbar

            Case %IDM_Test


         End Select

      Case %WM_Notify
         Select Case Cb.NmId
            Case %IDC_StatusBar : ManageLock

            Case %IDT_Home To %IDT_Help
               Select Case Cb.NmCode
                  Case %TTN_GetDispInfo
                     PTT = Cb.LParam
                     Select Case Cb.NmId
                        Case %IDT_Parent     : @PTT.@lpszText = "Enter Parent Mode"
                        Case %IDT_Child      : @PTT.@lpszText = "Enter Child Mode"
                        Case %IDT_Edit       : @PTT.@lpszText = "Manually Edit Site List"
                        Case %IDT_Add        : @PTT.@lpszText = "Add Displayed Site to Safe Site List"
                        Case %IDT_Remove     : @PTT.@lpszText = "Remove Selected Site from Safe Site List"
                        Case %IDT_Capture    : @PTT.@lpszText = "Create Site Preview Image"
                        Case %IDT_Password   : @PTT.@lpszText = "Change Password"
                        Case %IDT_Next       : @PTT.@lpszText = "Next Page"
                        Case %IDT_Previous   : @PTT.@lpszText = "Previous Page"
                        Case %IDT_Home       : @PTT.@lpszText = "Go To: " + HomeSite

                        Case %IDT_SoundMinus : @PTT.@lpszText = "Lower the Sound"
                        Case %IDT_SoundBlock : @PTT.@lpszText = "Mute the Sound"
                        Case %IDT_SoundPlus  : @PTT.@lpszText = "Raise the Sound"

                        Case %IDT_Print      : @PTT.@lpszText = "Print Page"
                        Case %IDT_Help       : @PTT.@lpszText = "Open Online Help Page"
                     End Select
               End Select

            Case %IDC_Toolbar
               Select Case Cb.NmCode
                  Case %TBN_DROPDOWN
                     nmtb = Cb.LParam
                     SendMessage(hToolbar, %TB_GETRECT, @nmtb.iItem, VarPtr(rc))
                     MapWindowPoints(hToolbar, %HWND_Desktop, ByVal VarPtr(rc), 2)
                     Select Case @nmtb.iItem
                        Case %IDT_Capture
                           Call TrackPopupMenu (hCapture, 0, rc.nLeft, rc.nBottom, 0, CbHndl, ByVal %Null)
                        Case %IDT_Settings
                           Call TrackPopupMenu (hSettings, 0, rc.nLeft, rc.nBottom, 0, CbHndl, ByVal %Null)
                        Case %IDT_Settings
                           Call TrackPopupMenu (hTimer, 0, rc.nLeft, rc.nBottom, 0, CbHndl, ByVal %Null)
                     End Select
               End Select
         End Select
      Case %WM_Size
         ResizeWindow
      Case %WM_Destroy
         KillTimer hDlg, %ID_Timer
         Array Scan Sites(), Collate UCase, = WebSite, To iResult
         If (iResult=0) And (UBound(Sites)>0) Then WebSite = Sites(1)  'in case Admin was viewing unapproved site
         Admin = 0
         settings_ini "save"
   End Select
End Function

Sub RunChangePSW
   Local temp$, iReturn As Long
   SaveSiteList                                     'save new list
   MD5 = GetMD5(Trim$(Join$(Sites(),$CrLf),$CrLf))  'get MD5 of new list
   temp$ = Resource$(RcData,%Res_EXE)               'restore gbChangePSW.exe
   Open "gbchangepsw.exe" For Output As #1
   Print #1, temp$;
   Close #1
   iReturn = Shell("gbchangepsw.exe " + IIf$(Len(NewPSW),NewPsw,Trim$(Resource$(String,%Res_PSW))) + " " + MD5 + Str$(AllDomain) + " " + Str$(TimeRemaining) + " " + IIf$(Restart, " Restart",""))
End Sub

Sub InitializeCrypto
   'md5 initialization
   If GetCSPHandle(hProv) < 2 Then
      SupportsMD5 = 0
      If hProv Then CryptReleaseContext hProv, 0
   Else
      SupportsMD5 = 1
      strHashPtr = VarPtr(strHash)
   End If
End Sub

Function ManageToolbar() As Long
   Local x,y,w,h As Long, temp$
   Dialog Get Client hDlg To w,h
   Dialog Get Loc hDlg To x,y
   If Admin Then
      ghHook = SetWindowsHookEx(%WH_CBT, CodePtr(InputBoxProc), GetModuleHandle(""), GetCurrentThreadId)
      temp$ = InputBox$("", "Enter Parental Password:", temp$, x+100,y+100)
      UnhookWindowsHookEx ghHook
      If Trim$(temp$)<>Trim$(Resource$(String,%Res_PSW)) Then Admin = 0 : Beep
   End If
   Control Kill hDlg, %IDC_Toolbar
   CreateToolbar

   If DirtyList Then
      Restart = 1
      MsgBoxX "gbChildSafe must restart to recognize the Parental changes!", %MB_Ok + %MB_TaskModal + %MB_IconExclamation, "Parental Mode"
      Function = 1
   End If
End Function

Sub BuildAcceleratorTable
   Local c As Long, ac() As ACCELAPI, hAccelerator As Dword  ' for keyboard accelator table values
   Dim ac(4)
   ac(c).fvirt = %FVIRTKEY              : ac(c).key   = %VK_F1 : ac(c).cmd   = %IDT_Help   : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_E  : ac(c).cmd   = %IDT_Edit     : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_L  : ac(c).cmd   = %IDM_Lock     : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_S  : ac(c).cmd   = %IDT_Capture  : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_T  : ac(c).cmd   = %IDM_Test     : Incr c
   Accel Attach hDlg, AC() To hAccelerator
End Sub

Sub CreateWebBrowser
   pWindow = Class "CWindow"
   pWBEvents = Class "CDWebBrowserEvents2"
   hBrowser = pWindow.AddWebBrowserControl(hDlg, %IDC_WEBBROWSER, (WebSite),pWBEvents, 110, %TBM, 600,300)
End Sub

Class CDWebBrowserEvents2 Guid$("{700B73A2-CCFC-4FE0-B9AC-D5853D71B7B9}") As Event
   Interface DWebBrowserEvents2Impl Guid$("{34A715A0-6587-11D0-924A-0020AFC7AC4D}") As Event
      Inherit IDispatch

      Method DocumentComplete <259> (ByVal pDisp As IDispatch, ByRef vURL As Variant)
         Local pIWebBrowser2 As IWebBrowser2
         Local pIHTMLDocument2 As IHTMLDocument2
         Local pICustomDoc As ICustomDoc
         Local pDocHostUIHandler As IDocHostUIHandler2Impl
         pIWebBrowser2 = pDisp
         If IsNothing(pIWebBrowser2) Then Exit Method
         pIHTMLDocument2 = pIWebBrowser2.Document
         If IsNothing(pIHTMLDocument2) Then Exit Method
         pICustomDoc = pIHTMLDocument2
         If IsNothing(pICustomDoc) Then Exit Method
         pDocHostUIHandler = Class "CDocHostUIHandler2"
         If IsObject(pDocHostUIHandler) Then
            pICustomDoc.SetUIHandler(pDocHostUIHandler)
         End If
      End Method

      Method StatusTextChange <102> ( _
        ByVal bstrText As WString _                        ' __in BSTR Text
      )                                                    ' void

         'dislay URL when mouse moves over active line
         If Left$(LCase$(bstrText),5) = "http:" Or Left$(LCase$(bstrText),5) = "file:" Or Left$(LCase$(bstrText),6) = "https:" Then
            Statusbar Set Text hDlg, %IDC_Statusbar, 2,0, bstrText
         End If
      End Method

      Method BeforeNavigate2 <250> ( _
        ByVal pDisp As IDispatch _                         ' __in IDispatch* pDisp
      , ByRef vURL As Variant _                            ' __in VARIANT* URL
      , ByRef vFlags As Variant _                          ' __in VARIANT* Flags
      , ByRef vTargetFrameName As Variant _                ' __in VARIANT* TargetFrameName
      , ByRef vPostData As Variant _                       ' __in VARIANT* PostData
      , ByRef vHeaders As Variant _                        ' __in VARIANT* Headers
      , ByRef Cancel As Integer _                          ' __in_out VARIANT_BOOL* Cancel
      )                                                    ' void
         If Variant$(vURL) <> "about:blank" Then
            Local temp$
            temp$ = Variant$(vURL)
            If InStr(LCase$(temp$),LCase$(SafeSiteName(WebSite))) = 0 Then       'stay within the site
               Cancel = %Variant_True
            End If
         End If
      End Method

      Method NewWindow3 <273> ( _
        ByRef ppDisp As IDispatch _                        ' __in_out IDispatch** ppDisp
      , ByRef bCancel As Integer _                         ' __in_out VARIANT_BOOL* Cancel
      , ByVal dwFlags As Dword _                           ' __in unsigned long dwFlags
      , ByVal bstrUrlContext As WString _                  ' __in BSTR bstrUrlContext
      , ByVal bstrUrl As WString _                         ' __in BSTR bstrUrl
      )                                                    ' void
         bCancel = %Variant_True
      End Method

   End Interface
End Class

Sub SetMenusAndToolbar
   'Control visibility
   Control Show State hDlg, %IDC_TextBox, IIf(Admin, %SW_Show, %SW_Hide)
   Control Show State hDlg, %IDC_ImgButton, IIf(Admin, %SW_Show, %SW_Hide)
   'Toolbar Buttons
    Toolbar Set State hDlg, %IDC_Toolbar, ByCmd %IDT_SoundBlock, IIf(Mute,%TBState_Checked,0) Or %TBState_Enabled
   'Menus
    Menu Set State hSettings, ByCmd %IDM_AllDomain,   IIf(AllDomain,%MFS_Checked,0) Or %MFS_Enabled
    Menu Set State hCapture, ByCmd %IDM_Capture64,   IIf(CaptureSize=64,%MFS_Checked,0) Or %MFS_Enabled
    Menu Set State hCapture, ByCmd %IDM_Capture128,  IIf(CaptureSize=128,%MFS_Checked,0) Or %MFS_Enabled
    Menu Set State hCapture, ByCmd %IDM_Capture192,  IIf(CaptureSize=192,%MFS_Checked,0) Or %MFS_Enabled
    Menu Set State hCapture, ByCmd %IDM_Capture256,  IIf(CaptureSize=256,%MFS_Checked,0) Or %MFS_Enabled
    Menu Set State hTimer,   ByCmd %IDM_Timer1,   IIf(TimeSlot=1,%MFS_Checked,0) Or %MFS_Enabled
    Menu Set State hTimer,   ByCmd %IDM_Timer2,   IIf(TimeSlot=2,%MFS_Checked,0) Or %MFS_Enabled
    Menu Set State hTimer,   ByCmd %IDM_Timer4,   IIf(TimeSlot=4,%MFS_Checked,0) Or %MFS_Enabled
    Menu Set State hTimer,   ByCmd %IDM_Timer8,   IIf(TimeSlot=8,%MFS_Checked,0) Or %MFS_Enabled
End Sub

Sub CreateContextMenus
   Menu New PopUp To hSettings
   Menu Add String, hSettings, "Full Site Access",    %IDM_AllDomain,    %MF_Enabled

   Menu New PopUp To hContextWB
   Menu Add String, hContextWB, "Set Selected Site As Home Site",    %IDM_SetAsHomeSite,    %MF_Enabled

   Menu New PopUp To hContextG
   Menu Add String, hContextG, "Move To Top",    %IDM_MoveToTop,    %MF_Enabled
   Menu Add String, hContextG, "Select BG Color ...", %IDM_BGColor, %MF_Enabled
   Menu Add String, hContextG, "-",    %IDM_Sep,    %MF_Enabled
   Menu Add String, hContextG, "Set As Home Site",    %IDM_SetAsHomeSite,    %MF_Enabled

   Menu New PopUp To hCapture
   Menu Add String, hCapture, "64",    %IDM_Capture64,    %MF_Enabled
   Menu Add String, hCapture, "128",   %IDM_Capture128,   %MF_Enabled
   Menu Add String, hCapture, "192",   %IDM_Capture192,   %MF_Enabled
   Menu Add String, hCapture, "256",   %IDM_Capture256,   %MF_Enabled

   Menu New PopUp To hTimer
   Menu Add String, hTimer, "1 hr.",    %IDM_Timer1, %MF_Enabled
   Menu Add String, hTimer, "2 hrs.",   %IDM_Timer2, %MF_Enabled
   Menu Add String, hTimer, "4 hrs.",   %IDM_Timer4, %MF_Enabled
   Menu Add String, hTimer, "8 hrs.",   %IDM_Timer8, %MF_Enabled
End Sub

Sub CreateToolbar
    Local hImageList As Dword
    ImageList New Icon 24,24,24,50 To hImageList
    ImageList Add Icon hImageList, "logo"         '1
    ImageList Add Icon hImageList, "xsettings"    '2
    ImageList Add Icon hImageList, "xhelp"        '3
    ImageList Add Icon hImageList, "xxprint"      '4
    ImageList Add Icon hImageList, "xplus"        '5
    ImageList Add Icon hImageList, "xminus"       '6
    ImageList Add Icon hImageList, "xnext"        '7
    ImageList Add Icon hImageList, "xprevious"    '8
    ImageList Add Icon hImageList, "xhome"        '9
    ImageList Add Icon hImageList, "xcapture"     '10
    ImageList Add Icon hImageList, "xedit"        '11
    ImageList Add Icon hImageList, "xlock"        '12
    ImageList Add Icon hImageList, "xsave"        '13
    ImageList Add Icon hImageList, "xsoundblock"  '14
    ImageList Add Icon hImageList, "xsoundplus"   '15
    ImageList Add Icon hImageList, "xsoundminus"  '16
    ImageList Add Icon hImageList, "xparent"      '17
    ImageList Add Icon hImageList, "xchild"       '18
    ImageList Add Icon hImageList, "xtimer"       '19

    Control Add Toolbar, hDlg, %IDC_Toolbar,"", 0,0,0,0,%TbStyle_Tooltips Or %TbStyle_Flat Or %WS_Child
    Control Handle hDlg, %IDC_Toolbar To hToolbar
    SendMessage hToolbar, %TB_SETEXTENDEDSTYLE, 0, %TBSTYLE_EX_DRAWDDARROWS

    Toolbar Set ImageList hDlg, %IDC_Toolbar, hImageList, 0

    If Admin Then
       Toolbar Add Button    hDlg, %IDC_Toolbar, 18,  %IDT_Parent, %BTNS_Button, "Child"
    Else
       Toolbar Add Button    hDlg, %IDC_Toolbar, 17,  %IDT_Parent, %BTNS_Button, "Parent"
    End If
    Toolbar Add Separator hDlg, %IDC_Toolbar, 20
    If Admin Then
       Toolbar Add Button    hDlg, %IDC_Toolbar, 11,  %IDT_Edit, %BTNS_Button, "Edit Sites"
       Toolbar Add Button    hDlg, %IDC_Toolbar, 5,  %IDT_Add, %BTNS_Button, "Add"
       Toolbar Add Button    hDlg, %IDC_Toolbar, 6,  %IDT_Remove, %BTNS_Button, "Remove"
       Toolbar Add Button    hDlg, %IDC_Toolbar, 12,  %IDT_Password, %BTNS_Button, "New PSW"
       Toolbar Add Button    hDlg, %IDC_Toolbar, 19,  %IDT_Timer,  %BTNS_Button Or %BTNS_DropDown, "Time"
       Toolbar Add Button    hDlg, %IDC_Toolbar, 2,  %IDT_Settings,  %BTNS_Button Or %BTNS_DropDown, "Settings"
       Toolbar Add Separator hDlg, %IDC_Toolbar, 20
    End If
    Toolbar Add Button    hDlg, %IDC_Toolbar, 8,  %IDT_Previous, %BTNS_Button, "Prev"
    Toolbar Add Button    hDlg, %IDC_Toolbar, 7,  %IDT_Next, %BTNS_Button, "Next"
    Toolbar Add Separator hDlg, %IDC_Toolbar, 20
    Toolbar Add Button    hDlg, %IDC_Toolbar, 10,  %IDT_Capture, %BTNS_Button Or %BTNS_DropDown, "SnapShot"
    Toolbar Add Button    hDlg, %IDC_Toolbar, 9,  %IDT_Home, %BTNS_Button, "Home"
    Toolbar Add Separator hDlg, %IDC_Toolbar, 20
    Toolbar Add Button    hDlg, %IDC_Toolbar, 16,  %IDT_SoundMinus, %BTNS_Button, "Lower"
    Toolbar Add Button    hDlg, %IDC_Toolbar, 14,  %IDT_SoundBlock, %BTNS_Button, "Mute"
    Toolbar Add Button    hDlg, %IDC_Toolbar, 15,  %IDT_SoundPlus, %BTNS_Button, "Higher"
    Toolbar Add Separator hDlg, %IDC_Toolbar, 20
    Toolbar Add Button    hDlg, %IDC_Toolbar, 4,  %IDT_Print, %BTNS_Button, "Print"
    Toolbar Add Button    hDlg, %IDC_Toolbar, 3,  %IDT_Help,  %BTNS_Button, "Help"
End Sub

Sub Settings_INI(Task$)
   Local x,y As Long
   Local xResult, yResult, temp, INIFileName As WStringZ*%Max_Path
   INIFileName = Exe.Path$ + Exe.Name$ + ".ini"
   If Task$ = "get" Then
      'get dialog top/left from INI file and use to set Dialog location
      Getprivateprofilestring "All", "Left", "100", xResult, %Max_Path, INIFileName
      Getprivateprofilestring "All", "Top", "100", yResult, %Max_Path, INIFileName
      Dialog Set Loc hDlg, Val(xResult), Val(yResult)   'left/top

      'get dialog width/height from INI file and use to set Dialog size
      GetPrivateProfileString "All", "Width", "750", xResult, %Max_Path, INIFileName
      GetPrivateProfileString "All", "Height", "500", yResult, %Max_Path, INIFileName
      Dialog Set Size hDlg,Val(xResult), Val(yResult)   'width/height

      'get value for string variables
      Getprivateprofilestring "All", "WebSite", "", temp, %Max_Path, INIFileName : WebSite = temp
      Getprivateprofilestring "All", "HomeSite", "http://www.howstuffworks.com/", temp, %Max_Path, INIFileName : HomeSite = temp

      'get value for numeric variables
      Getprivateprofilestring "All", "CurrentSite", "1", temp, %Max_Path, INIFileName:  CurrentSite = Val(temp)
      Getprivateprofilestring "All", "CaptureSize", "256", temp, %Max_Path, INIFileName:  CaptureSize = Val(temp)
      Getprivateprofilestring "All", "Mute", "0", temp, %Max_Path, INIFileName:  Mute = Val(temp)
      Getprivateprofilestring "All", "BGColor", Str$(%rgb_LightGreen), temp, %Max_Path, INIFileName:  BGColor = Val(temp)

      For x = 0 To 15
         Getprivateprofilestring "All", "CustomColorC" + Format$(x,"00"), "", temp, %Max_Path, INIFileName
         CustomColorList.c(x) = Val(temp)
      Next x

   End If

   If Task$ = "save" Then
      'save dialog size/location unless minimized or maximized
      If IsFalse(IsIconic(hDlg) Or IsZoomed(hDlg)) Then
         Dialog Get Loc hDlg To x,y
         WritePrivateProfileString "All", "Left", Str$(x), INIFileName
         WritePrivateProfileString "All", "Top", Str$(y), INIFileName
         Dialog Get Size hDlg To x,y
         WritePrivateProfileString "All", "Width", Str$(x), INIFileName
         WritePrivateProfileString "All", "Height", Str$(y), INIFileName
      End If
      'save string variables
      WritePrivateProfileString "All", "WebSite", (WebSite), INIFileName
      WritePrivateProfileString "All", "HomeSite", (HomeSite), INIFileName

      'save numeric variables
      WritePrivateProfileString "All", "CurrentSite", Str$(CurrentSite), INIFileName
      WritePrivateProfileString "All", "CaptureSize", Str$(CaptureSize), INIFileName
      WritePrivateProfileString "All", "Mute", Str$(Mute), INIFileName
      WritePrivateProfileString "All", "BGColor", Str$(BgColor), INIFileName

      For x = 0 To 15
         temp = Str$(CustomColorList.c(x))
         WritePrivateProfileString "All", "CustomColorC" + Format$(x,"00"), temp, INIFileName
      Next x
   End If
End Sub

Sub CreateGraphic
   Control Add Graphic, hDlg, %IDC_Graphic,"", 5, %TBM,100,80, %SS_Notify, %WS_Ex_ClientEdge
   Control Handle hDlg, %IDC_Graphic To hGraphic
   Graphic Attach hDlg, %IDC_Graphic, ReDraw
   Graphic Width 2
   Graphic Get DC To hGraphicDC
   Graphic Color %Black, BGColor
   Graphic Set Overlap
End Sub

Sub ResizeWindow
   Local w,h As Long
   Dialog Get Client hDlg To w,h
   If Admin=1 Then
      Control Set Loc hDlg, %IDC_ImgButton, w-30, %TBM
      Control Set Size hDlg, %IDC_TextBox, w-145,25
      Control Set Loc hDlg, %IDC_WebBrowser, 110, %TBM + 30
      Control Set Size hDlg, %IDC_WebBrowser, w-115,h-%TBM-55
   Else
      Control Set Loc hDlg, %IDC_WebBrowser, 110, %TBM
      Control Set Size hDlg, %IDC_WebBrowser, w-115,h-%TBM-25
   End If

   Control Set Size hDlg, %IDC_Graphic, 100, h-%TBM-25
   Select Case UBound(Sites)*80 + 20
      Case < h-%TBM-25           : Graphic Set Virtual 80,h-%TBM-25
      Case < Graphic(Canvas.Y)   : Graphic Set Virtual 80, UBound(Sites)*80 + 20
   End Select

End Sub

Function GetSiteList() As String
   Local temp$
   If IsFile($SafeSites) Then
      Open $SafeSites For Binary As #1
      Get$ #1, Lof(1), temp$
      Close #1
      temp$ = Trim$(temp$,$CrLf)
      ReDim Sites(ParseCount(temp$,$CrLf))   'zero position not used
      Parse temp$,Sites(),$CrLf
      Array Insert Sites(0), ""
   Else
      ReDim Sites(0)
   End If
End Function

Function SaveSiteList() As String
   Open $SafeSites For Output As #1
   Print #1, Trim$(Join$(Sites(),$CrLf),$CrLf);
   Close #1
End Function

Function InputBoxProc(ByVal nCode As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
   Local szTemp As WStringZ * %Max_Path, cw As CBT_CREATEWND Ptr, cst As CREATESTRUCT Ptr, iStyle As Long
   Function = CallNextHookEx(ByVal ghHook, ByVal nCode, ByVal wParam, ByVal lParam)
   If nCode < 0 Then Exit Function
   If nCode = %HCBT_ACTIVATE Then UnhookWindowsHookEx ghHook
   If nCode = %HCBT_CREATEWND Then
      cw = lParam : cst = @cw.lpcs                ' get a pointer to the CREATESTRUCT struct
      GetClassName wParam, szTemp, %Max_Path      ' for each window / control as it is created
      If UCase$(szTemp) = "BUTTON" Then
         Select Case @cst.hMenu
            Case %IdOk   :   @cst.x=20:@cst.y=40:@cst.cx=60
            Case %IdCancel : @cst.x=110:@cst.y=40:@cst.cx=60
         End Select
      End If
      If UCase$(szTemp) = "STATIC" Then @cst.x = 400  'prompt moved out of the way
      If UCase$(szTemp) = "EDIT"   Then
         @cst.x = 10   : @cst.y = 10 : @cst.cx = 175 : @cst.cy = 30
         iStyle = GetWindowLong(wParam,%GWL_Style)
         SetWindowLong wparam, %GWL_Style, iStyle Or %ES_Password
      End If
      If UCase$(szTemp) = "#32770" Then @cst.cx = 200 : @cst.cy = 100  'dialog
   End If
End Function

Sub CreateWebSiteImageDefault
   Local hBMP,hDC,hDeskTopDC As Dword, x,y, r,s As Long
   'create memory bitmap to hold image
   Graphic Bitmap New 64,64 To hBMP
   Graphic Attach hBMP, 0
   Graphic Get DC To hDC

   'copy image from desktop (webbrowser control)
   Dialog Get Loc hDlg To x,y
   Control Get Loc hDlg, %IDC_WebBrowser To r,s
   hDeskTopDC = GetDC(%Null)
   StretchBlt hDC, 0,0,64,64, hDeskTopDC,x+r,y+s,256,256,%SRCCopy 'copy desktop image to
   ReleaseDC(%Null,hDeskTopDC)

   'save image
   Graphic Save BMPFileName(WebSite)
   Graphic Bitmap End

   'reattach main graphic
   Graphic Attach hDlg, %IDC_Graphic, ReDraw
End Sub

Function BMPFileName(ByVal temp$) As String 'must be of format:  http://www.garybeene.com/
   Replace "http://" With "" In temp$    'remove http://
   temp$ = Parse$(temp$,"/",1)        'every thing to the left of 1st "/"
   Replace "." With "" In temp$
   Function = "images\" + temp$ + ".bmp"
End Function

Sub AddNewSite
   ReDim Preserve Sites(UBound(Sites)+1)
   Array Insert Sites(1), WebSite
   CurrentSite = 1
   SaveSiteList
   DrawPreviewImages
End Sub

Sub DrawPreviewImages   'draw 64x64 images on the Graphic Control
   Local i,y As Long
   Graphic Attach hDlg, %IDC_Graphic, ReDraw
   Graphic Color %Black, BGColor
   Graphic Clear
   For i = 1 To UBound(Sites)
      y = (i-1)*80 + 20
      If IsFile(BMPFileName(Sites(i))) Then
         Graphic Render Bitmap BMPFileName(Sites(i)), (5,y)-(68,y+63)
      Else
         Graphic Render Bitmap "images\unknown.bmp", (5,y)-(68,y+63)
      End If
      If i = CurrentSite Then   'Draw red box (selection)
         Graphic Box (4,y-1)-(70,y+65), , %Red
      End If
   Next i
   Graphic ReDraw
End Sub

Function GetMD5(ByVal strText As String) As String
   Register i As Long
   Local hHash As Dword, hText As String

   CryptCreateHash( hProv, %CALG_MD5, 0, 0, hHash )
   CryptHashData( hHash, ByVal StrPtr(strText), Len(strText), 0 )
   CryptGetHashParamX( hHash, %HP_HASHVAL, strHashPtr, 16, 0 )
   CryptDestroyHash hHash

   For i = 0 To 15
      hText += Hex$( @strHashPtr[i], 2 )
   Next
   Function = hText
End Function

Function GetCSPHandle(hCSP As Dword) As Long
   If CryptAcquireContext( hCSP, ByVal %Null, ByVal %Null, %PROV_RSA_AES, 0 ) = %False Then
      ' Unable To Find a Default For %PROV_RSA_AES so force the issue first For Vista And above
      If CryptAcquireContext( hCSP, ByVal %Null, $MS_ENH_RSA_AES_PROV_A, %PROV_RSA_AES, %CRYPT_VERIFYCONTEXT ) = %False Then
         ' Still failed so force the issue With XP SP3
         If CryptAcquireContext( hCSP, ByVal %Null, $MS_ENH_RSA_AES_PROV_XP_A, %PROV_RSA_AES, %CRYPT_VERIFYCONTEXT ) = %False Then
            ' Stll failed so Try And Find a Default For < XP SP3
            If CryptAcquireContext( hCSP, ByVal %Null, ByVal %Null, %PROV_RSA_FULL, 0 ) = %FALSE Then
               ' Unable To Find a Default For %PROV_RSA_FULL failed so force the issue
               If CryptAcquireContext( hCSP, ByVal %Null,$MS_DEF_PROV_A, %PROV_RSA_FULL, %CRYPT_VERIFYCONTEXT ) = %FALSE Then
                  Function = 0
               Else
                  Function = 1 ' < XP SP3
               End If
            Else ' found Default %PROV_RSA_FULL
               Function = 1
            End If
         Else
            Function = 2 ' XP SP3
         End If
      Else
         Function = 3 ' Vista And above
      End If
   Else ' found Default %PROV_RSA_AES
      Function = 3
   End If
End Function

Function SiteListTampered() As Long
   Local temp$
   temp$ = Trim$(Join$(Sites(),$CrLf),$CrLf)
   temp$ = GetMD5(temp$)
   If Resource$(String,%Res_MD5) <> temp$ Then
      'plainttext file not valid
      MsgBoxX "The web site list has been tampered with." + $CrLf + "gbChildSafe will close!", %MB_Ok + %MB_TaskModal + %MB_IconInformation, "Site Validation"
      Function = 1
   End If
End Function

Function MsgBoxX(msg$,Flag As Long,caption$) As Long
   ghHook = SetWindowsHookEx(%WH_CBT, CodePtr(SBProc), GetModuleHandle(""), GetCurrentThreadId)
   Function = MessageBox( 0, (msg$), (caption$), Flag)
End Function

Function SBProc(ByVal lMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
   Local x As Long, y As Long    'MsgBoxX is approximately 200x200
   CenterOverDialog 370,170,x,y
   If lMsg = %HCBT_ACTIVATE Then
      SetWindowPos wParam, 0, x,y, 0, 0, %SWP_NOSIZE Or %SWP_NOACTIVATE Or %SWP_NOZORDER
      UnhookWindowsHookEx ghHook
   End If
End Function

Sub CenterOverDialog(BoxX As Long, BoxY As Long, CenterX As Long, CenterY As Long)
   'gets top/left position to center Box over Dialog
   'you need to know, or at least estimate, the Box size
   Local x,y,ww,hh As Long
   Dialog Get Loc hDlg To x,y
   Dialog Get Size hDlg To ww,hh
   CenterX = x + (ww-BoxX)/2
   CenterY = y + (hh-BoxY)/2
End Sub

Sub ManageVolume(Task As Long)
    Local pIMMDeviceEnumerator  As IMMDeviceEnumerator
    Local pIMMDevice            As IMMDevice
    Local pIAudioEndpointVolume As IAudioEndpointVolume
    Local vol                   As Single

    pIMMDeviceEnumerator = NewCom ClsId $CLSID_MMDeviceEnumerator
    If IsObject(pIMMDeviceEnumerator) Then
        pIMMDeviceEnumerator.GetDefaultAudioEndpoint(%EDataFlow_eRender, %ERole_eMultimedia, pIMMDevice)
        If IsObject(pIMMDevice) Then
            pIMMDevice.Activate($IID_IAudioEndpointVolume, %CLSCTX_ALL, ByVal %NULL, pIAudioEndpointVolume)
            If IsObject(pIAudioEndpointVolume) Then
                pIAudioEndpointVolume.GetMasterVolumeLevelScalar(vol)

                pIAudioEndpointVolume.SetMute(%False, ByVal %NULL)
                Select Case Task
                   Case -1
                      vol = Max(0, 0.8 * vol)  'nothing small than 0
                      pIAudioEndpointVolume.SetMasterVolumeLevelScalar(vol, ByVal %NULL)
                   Case  0
                      If Mute = 1 Then pIAudioEndpointVolume.SetMute(%True, ByVal %NULL)
                   Case +1
                      vol = Min(1, 1.2 * vol)  'nothing bigger than 1
                      pIAudioEndpointVolume.SetMasterVolumeLevelScalar(vol, ByVal %NULL)
                End Select

            End If
        End If
    End If
    pIMMDeviceEnumerator  = Nothing
    pIMMDevice            = Nothing
    pIAudioEndpointVolume = Nothing
    Statusbar Set Text hDlg, %IDC_StatusBar, 2,0, "Volume: " + Format$(vol,"0.00") + "     Mute: " + IIf$(Mute,"On","Off")
End Sub


Class CDocHostUIHandler2 As Common   ' // Use AS COMMON to avoid removal of methods
   Interface IDocHostUIHandler2Impl $IID_IDocHostUIHandler2
      Inherit IUnknown

      Method ShowContextMenu (ByVal dwID As Dword, ByRef ppt As Point, ByVal pcmdtReserved As IUnknown, ByVal pdispReserved As IDispatch) As Long
         TrackPopupMenu hContextWB, %TPM_LeftAlign, ppt.x, ppt.y, 0, hDlg, ByVal 0
         Method = %S_Ok
      End Method

      Method GetHostInfo (ByRef pInfo As DOCHOSTUIINFO) As Long
         If VarPtr(pInfo) Then
            pInfo.cbSize = SizeOf(DOCHOSTUIINFO)
            pInfo.dwFlags = %DOCHOSTUIFLAG_NO3DBORDER Or %DOCHOSTUIFLAG_THEME
            pInfo.dwDoubleClick = %DOCHOSTUIDBLCLK_DEFAULT
            pInfo.pchHostCss = %NULL
            pInfo.pchHostNS = %NULL
         End If
         Method = %S_Ok
      End Method

      Method ShowUI (ByVal dwID As Dword, ByVal pActiveObject As IOleInPlaceActiveObject, ByVal pCommandTarget As IOleCommandTarget _
                     , ByVal pFrame As IOleInPlaceFrame, ByVal pDoc As IOleInPlaceUIWindow) As Long : End Method
      Method HideUI () As Long : End Method
      Method UpdateUI () As Long : End Method
      Method EnableModeless (ByVal fEnable As Long) As Long : End Method
      Method OnDocWindowActivate (ByVal fActivate As Long) : End Method
      Method OnFrameWindowActivate (ByVal fActivate As Long) As Long : End Method
      Method ResizeBorder (ByRef prcBorder As RECT, ByVal pUIWindow As IOleInPlaceUIWindow, ByVal fRameWindow As Long) As Long : End Method

      Method TranslateAccelerator (ByRef lpMsg As tagMSG, ByRef pguidCmdGroup As Guid, ByVal nCmdID As Dword) As Long
         Method = %S_False
      End Method

      Method GetOptionKeyPath (ByRef pchKey As Dword,ByVal dw_ As Dword) As Long
         pchKey = %NULL
      End Method

      Method GetDropTarget (ByVal pDropTarget As IDropTarget, ByRef ppDropTarget As IDropTarget) As Long
         ppDropTarget = Nothing
         Method = %E_NotImpl
      End Method

      Method GetExternal (ByRef ppDispatch As IDispatch) As Long
         ppDispatch = Nothing
         Method = %S_False
      End Method

      Method TranslateUrl (ByVal dwTranslate As Dword, ByRef pchURLIn As WStringZ, ByRef ppchURLOut As WStringZ) As Long
         ppchURLOut = ""
         Method = %S_False
      End Method

      Method FilterDataObject (ByVal pDO As IDataObject, ByRef ppDORet As IDataObject) As Long
         ppDORet = Nothing
         Method = %S_False
      End Method

      Method GetOverrideKeyPath (ByRef pchKey As Dword, ByVal dw_ As Dword) As Long
         pchKey = %NULL
      End Method
   End Interface
End Class

Function SelectColor(startcolor&) As Long    'works on pControl
   Local ColorResult&
   Display Color hDlg, 200, 200, startcolor&, CustomColorList ,0 To ColorResult&
   If ColorResult& = -1 Then Function = startcolor& Else Function = ColorResult&
End Function

Sub CreateImageCaptureDialog
   Dialog New Pixels, hDlg, "", 100,190,CaptureSize, CaptureSize, %WS_Popup + %WS_Border, %WS_Ex_Layered To hDlgC
   Dialog Show Modal hDlgC Call DlgCProc
End Sub

CallBack Function DlgCProc() As Long
   Select Case Cb.Msg
      Case %WM_InitDialog
         SetLayeredWindowAttributes(hDlgC, 0, 120, %LWA_ALPHA)
      Case %WM_LButtonDown
         If Cb.WParam = %MK_LBUTTON Then SendMessage hDlgC, %WM_NCLButtonDown, %HTCaption, ByVal %Null  ' force drag
      Case %WM_LButtonDblClk
         CreateWebSiteImage
         DrawPreviewImages
         CaptureInWork = 0
         Dialog End hDlgC
         Statusbar Set Text hDlg, %IDC_StatusBar, 2, 0, "Image Captured"
      Case %WM_ContextMenu
         CaptureInWork = 0
         Dialog End hDlgC
   End Select
End Function

'Function ExactURL(byVal temp$) As String 'returns everything betwee "//" and "/"
'   Local iCount As Long
'   Replace "http://" With "" In temp$
'   Function = Parse$(temp$,"/",1)
'End Function

Function SafeSiteName(temp$) As String 'returns garybeene.com
   Replace "http://" With "" In temp$    'remove http://
   Function = Parse$(temp$,"/",1)        'every thing to the left of 1st "/"
   If AllDomain And ParseCount(temp$,".") = 3 Then
      Function = Parse$(temp$,".",2) + "." + Parse$(temp$,".",3)
   End If
End Function

Sub CreateWebSiteImagex
   Local hBMP,hDC,hDeskTopDC As Dword, rc As Rect
   'create memory bitmap to hold image
   Graphic Bitmap New 64,64 To hBMP
   Graphic Attach hBMP, 0
   Graphic Get DC To hDC

   'copy image from desktop (webbrowser control)
   GetWindowRect hDlgC, rc
   Dialog Show State hDlgC, %SW_Hide
   hDeskTopDC = GetDC(%Null)
   SetStretchBltMode hDC, %HalfTone
   StretchBlt hDC, 0,0,64,64, hDeskTopDC,rc.nLeft,rc.nTop,CaptureSize,CaptureSize,%SRCCopy 'copy desktop image to
   ReleaseDC(%Null,hDeskTopDC)

   'save image
   Graphic Save BMPFileName(WebSite)
   Graphic Bitmap End

   'reattach main graphic
   Graphic Attach hDlg, %IDC_Graphic, ReDraw
End Sub

Sub ManageLock
   Local x,y As Long
   Local pIWebBrowser2 As IWebBrowser2, vURL As Variant
   Admin Xor= 1

   If ManageToolbar Then
      Dialog End hDlg
   Else
      If Admin Then 'going to Parent Mode
         Dialog Get Size hDlg To x, y
         Dialog Set Size hDlg, Max(x,930), y
         Control Set Text hDlg, %IDC_TextBox, WebSite
         Control Set Focus hDlg, %IDC_TextBox
         Control Send hDlg, %IDC_TextBox, %EM_SetSel, 0, -1
      Else 'goint to Child Mode
         WebSite = Sites(CurrentSite)
         Statusbar Set Text hDlg, %IDC_Statusbar, 2, 0, WebSite
         vURL = WebSite
         pIWebBrowser2 = OC_GetDispatch(hBrowser)
         pIWebBrowser2.Navigate2 vURL
      End If
      ResizeWindow
      SetMenusAndToolbar
   End If
End Sub

Sub CreateWebSiteImage
   Local hBMP,hDC,hDialogDC As Dword, x,y,r,s,i,j As Long, rc As Rect
   'create memory bitmap to hold image
   Graphic Bitmap New 64,64 To hBMP
   Graphic Attach hBMP, 0
   Graphic Get DC To hDC

   'copy image from desktop (webbrowser control)
   Dialog Get Loc hDlgC To x,y
   hDialogDC = GetDC(hDlg)
   SetStretchBltMode hDC, %HalfTone
   StretchBlt hDC, 0,0,64,64, hDialogDC,x,y,CaptureSize,CaptureSize,%SRCCopy 'copy desktop image to
   ReleaseDC(hDlg,hDialogDC)

   'save image
   Graphic Save BMPFileName(WebSite)
   Graphic Bitmap End

   'reattach main graphic
   Graphic Attach hDlg, %IDC_Graphic, ReDraw
End Sub

Sub SetToolTip(hControl As Dword, TipText As WStringZ*256)
   Local TI As TOOLINFOW
   TI.cbSize    = SizeOf(TI)
   TI.uFlags    = %TTF_SUBCLASS Or %TTF_IDISHWND
   TI.hWnd      = GetParent(hToolTip)
   TI.uId       = hControl
   TI.lpszText  = VarPtr(TipText)
   SendMessage hToolTip, %TTM_ADDTOOL, 0, VarPtr(ti)
End Sub

Sub CreateImgButton
   Control Add ImgButton, hDlg, %IDC_ImgButton, "xarrow",370,%TBM,22,22
   Control Handle hDlg, %IDC_ImgButton To hImgButton
   hToolTip = CreateWindowEx(ByVal 0, "tooltips_class32", "", %TTS_ALWAYSTIP,  _
      0, 0, 0, 0, ByVal hDlg, ByVal 0, GetModuleHandle(ByVal %NULL), ByVal 0)
   SetToolTip(hImgButton, "Open Web Site")
End Sub

Function TimeString() As String
   Local h,m As Long
   h = TimeRemaining \ 3600
   m = (TimeRemaining Mod 3600) \ 60
   Function = Format$(h," 0") + ":" + Format$(m,"00")
End Function

Function SiteUnderCursor() As Long
   Local pt As Point
   GetCursorPos pt              'pt has xy screen coordinates
   ScreenToClient hGraphic, pt  'pt now has graphic client coordinates
   Function = (pt.y-20+Graphic(View.Y)) \ 80 + 1
End Function
